/***************************************************************************
 *   Copyright (C) 2004 by Markus Bader                                    *
 *   markus.bader@moresun.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "LAStreams.h"
#include "svd.h"
#include <iostream.h>
#include <vector>
#include <cstdlib>



using namespace std;

int main(int argc, char *argv[])
{
  cout << "SVD example samples!" << endl;
	const int m = 4;
	const int n = 3;
	Matrix A(m,n);
	float data[m*n]  = 
 	{
		2.00001,  0.9999,  	0.9999,
		1.0001,  	2.001,  	2.001,
		2.1002,  	3.99998,  3.99998,
		5,  			3,  			3
	};  
	// fill matrix
 {
 	MatrixDA Ad(A);
   for(int i = 1; i <= A.q_nrows(); i++)
	 for(int j = 1; j <= A.q_ncols(); j++)
	 	Ad(i,j) = data[(i-1)*A.q_ncols()+(j-1)];
 }
 
	A.print("Werte");
	SVD svd(A);
	Matrix V = svd.q_V();
	V.print("V");
	Matrix U = svd.q_U();
	U.print("U");
	Vector D = svd.q_sig();
	D.print("D");
	Vector x(V.q_ncols());
	
	
 	cout << "\ncondition number " << svd.q_cond_number() << endl;
	{
		MatrixDA Vd(V);
		int min = 1;
		int row = 0;
		for(int i = 1; i <= D.q_nrows(); i++)
		{
				if(D(i) < min)
				 	{
						min = D(i);
						row = i;
					}
					cout << D(i) << endl;
		}
		for(int i = 1; i <= V.q_ncols(); i++)
			x(i) = Vd(i,row);
	}
	x.print("Soloion for Zero");
	Vector b = A*x;
	b.print("test");
	cout << endl << "end SVD example!" << endl;
	
  return EXIT_SUCCESS;
	
	
}